#include "hjelpeFunksjoner.h"

using namespace std;

string HjelpeFunksjoner::rensStreng(const string str) {
    string rensetStreng, tmp, tmp2;
    int i = 0;
    bool alle;
    vector<string> ulovligeBokstaver = {
        "Æ",
        "æ",
        "Ø",
        "ø",
        "Å",
        "å"};
    vector<string> lovligeBokstaver = {
        "E",
        "e",
        "O",
        "o",
        "A",
        "a"};

    if (sjekkForUlovligTegn(str)) {
        regex re("[^ÆØÅæøåa-zA-Z0-9]");
        rensetStreng = regex_replace(str, re, "");
    } else
        rensetStreng = str;

    // Ikke den beste løsningen iom. at den looper gjennom strengen
    // flere ganger, en annen løsning kunne vært å bruke regex_replace igjen
    for (const auto& ulovlig : ulovligeBokstaver) {
        alle = false;
        while (!alle) {
            size_t pos = rensetStreng.find(ulovlig);
            if (pos != string::npos)
                rensetStreng.replace(pos,
                                     ulovligeBokstaver[i].length(),
                                     lovligeBokstaver[i]);
            else
                alle = true;
        }
        i++;
    }
    return rensetStreng;
}

bool HjelpeFunksjoner::sjekkForUlovligTegn(const string str) {
    regex re("[^ÆØÅæøåa-zA-Z0-9 ]");
    if (regex_search(str, re)) {
        cout << "\nUlovlig karakter(er) funnet! Venligst bare bruk: A-z 0-9"
             << '\n';
        return true;
    }
    return false;
}

bool HjelpeFunksjoner::erBokstav(const string str) {
    auto it = find_if(str.begin(), str.end(),
                      [](const char& val) { return isalpha(val) == true; });
    if (it == str.end()) {
        // cout << "\nTrue " << str << '\n';
        return true;
    }
    // cout << "\nfalse " << str << '\n';
    return false;
}

string HjelpeFunksjoner::gjorOmTilStorBokstav(const string& str) {
    string tmp = "";
    for (const auto& val : str) {
        tmp += toupper(val);
    }
    return tmp;
}

vector<string> HjelpeFunksjoner::splittStreng(const char& splittPa, const string& str) {
    vector<string> split;
    string tmp = "";
    for (const auto& val : str) {
        if (val == splittPa) {
            split.push_back(tmp);
            tmp = "";
        } else
            tmp += val;
    }
    split.push_back(tmp);
    return split;
}

void HjelpeFunksjoner::skrivKlokkeslett(const int& time, const int& min) {
    if (time <= 9)
        cout << "0" << time;
    else
        cout << time;
    cout << ":";
    if (min <= 9)
        cout << "0" << min;
    else
        cout << min;
}

// Basert på Frodes lesInt() funk fra lesData3.cpp
int HjelpeFunksjoner::lesTall() {
    char buffer[MAX_CHAR] = "";
    int tall = 0;
    bool feil = false;

    do {
        feil = false;
        cin.getline(buffer, MAX_CHAR);
        tall = atoi(buffer);
        if (tall == 0 && buffer[0] != '0') {
            feil = true;
            std::cout << "\nError: Ikke et tall!" << '\n';
        }
    } while (feil);

    return tall;
}